/*
Copyright (c) 2019-2023 Digital Energy Cloud Solutions LLC. All Rights Reserved.
Authors:
Petr Krutov, <petr.krutov@digitalenergy.online>
Stanislav Solovev, <spsolovev@digitalenergy.online>

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

/*
Terraform DECORT provider - manage resources provided by DECORT (Digital Energy Cloud
Orchestration Technology) with Terraform by Hashicorp.

Source code: https://repository.basistech.ru/BASIS/terraform-provider-decort

Please see README.md to learn where to place source code so that it
builds seamlessly.

Documentation: https://repository.basistech.ru/BASIS/terraform-provider-decort/wiki
*/

package pcidevice

import (
	"context"
	"fmt"
	"strconv"

	"github.com/hashicorp/terraform-plugin-sdk/v2/helper/schema"
	"repository.basistech.ru/BASIS/decort-golang-sdk/pkg/cloudbroker/pcidevice"
)

func utilityPcideviceCheckPresence(ctx context.Context, d *schema.ResourceData, m interface{}) (*pcidevice.ItemPCIDevice, error) {
	pcideviceList, err := utilityPcideviceListCheckPresence(ctx, m)
	if err != nil {
		return nil, err
	}

	var pcideviceId uint64

	if d.Id() != "" {
		id, _ := strconv.ParseUint(d.Id(), 10, 64)
		pcideviceId = id
	} else {
		pcideviceId = uint64(d.Get("device_id").(int))
	}

	for _, pd := range pcideviceList.Data {
		if pd.ID == pcideviceId {
			return &pd, nil
		}
	}

	return nil, fmt.Errorf("dataPcideviceRead: can't find Pcidevice because Device_id %d is not allowed or does not exist", d.Get("device_id").(int))
}
